//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TAguja.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

#include<math.h>

// TAguja

TAguja::TAguja(TImage *_Image,TPoint _Radio,int _Maximo)
{  Image=new TImage(Application->MainForm);
   Font =new TFont();

   Image=_Image;

   Radio =_Radio;
   Maximo=_Maximo;

   Centro=Point(Image->Width/2,Image->Height/2);
   Divisiones=Maximo;

   ColorAguja=clWhite;
   ColorEsfera=clLime;
   ColorFondo=clBlack;

   Numeros=true;
   Font->Color=clLime;
   Font->Name="Courier";
   Font->Size=8;

   Init();
}

// ~TAguja

TAguja::~TAguja()
{  delete Image;
   delete Font;
}

// Init

void TAguja::Init()
{  Posicion=0;

   Show();
}

// MoveTo

void TAguja::MoveTo(float pos)
{  ShowAguja(ColorFondo);

   Posicion=pos;
   ShowAguja(ColorAguja);
}

// Show

void TAguja::Show()
{  float a,coseno,seno;
   int h,i,x,y;

   Image->Canvas->Pen->Color=ColorEsfera;
   Image->Canvas->Pen->Width=3;

   if (Numeros)
   {  Image->Canvas->Font=Font;
      SetBkMode(Image->Canvas->Handle,TRANSPARENT);
      SetTextAlign(Image->Canvas->Handle,TA_CENTER);

      h=Image->Canvas->TextHeight("0");
   }

   for (i=0;i<Divisiones;i++)
   {  a=2.0*M_PI*float(i)/float(Divisiones);

      seno=sin(a);
      coseno=cos(a);

      x=int(float(Centro.x)+float(Radio.x)*0.95*seno);
      y=int(float(Centro.y)-float(Radio.y)*0.95*coseno);
      Image->Canvas->MoveTo(x,y);

      x=int(float(Centro.x)+float(Radio.x)*1.05*seno);
      y=int(float(Centro.y)-float(Radio.y)*1.05*coseno);
      Image->Canvas->LineTo(x,y);

      if (Numeros)
      {  x=int(float(Centro.x)+float(Radio.x)*1.25*seno);
         y=int(float(Centro.y)-float(Radio.y)*1.25*coseno)-h/2;
         Image->Canvas->TextOut(x,y,IntToStr(i*int(Maximo)/Divisiones));
      }
   }

   MoveTo(Posicion);

   Image->Canvas->Pen->Width=1;
}

// ShowAguja

void TAguja::ShowAguja(TColor c)
{  float a;
   int x,y;

   Image->Canvas->Pen->Color=c;
   Image->Canvas->Pen->Width=3;

   a=2.0*M_PI*Posicion/Maximo;

   Image->Canvas->MoveTo(Centro.x,Centro.y);
   x=int(float(Centro.x)+float(Radio.x)*0.85*sin(a));
   y=int(float(Centro.y)-float(Radio.y)*0.85*cos(a));
   Image->Canvas->LineTo(x,y);

   Image->Canvas->Pen->Width=1;
}
