//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TCrono.h"
#include "CronoU.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

#include<math.h>
#include<stdio.h>

// TCrono

TCrono::TCrono(TImage *_Image,TTimer *_Timer)
{  Image=new TImage(Application->MainForm);
   Font =new TFont();
   Timer=new TTimer(Application->MainForm);

   Image=_Image;
   Timer=_Timer;

   ImageFondo1=new TImage(Application->MainForm);
   ImageFondo2=new TImage(Application->MainForm);
   RaceFondoLoad();

   AgujaM=new TAguja(Image,Point(75,75),60);
   AgujaS=new TAguja(Image,Point(75,75),60);
   AgujaD=new TAguja(Image,Point(75,75),10);

   ColorFondo=clBlack;

   Font->Name="Times New Roman";
   Font->Color=TColor(RGB(150,100,255));
   Font->Size=102;

   AgujaM->Font->Color=clWhite;
   AgujaM->ColorEsfera=clLime;
   AgujaM->ColorAguja=clRed;
   AgujaM->Divisiones=6;
   AgujaM->Numeros=true;

   AgujaS->Font->Color=clWhite;
   AgujaS->ColorEsfera=clLime;
   AgujaS->ColorAguja=clRed;
   AgujaS->Divisiones=12;
   AgujaS->Numeros=true;

   AgujaD->Font->Color=clWhite;
   AgujaD->ColorEsfera=clLime;
   AgujaD->ColorAguja=clRed;
   AgujaD->Divisiones=10;
   AgujaD->Numeros=true;

   Sound=true;
   Style=1;

   TickStop=0;

   RaceLineColor=clRed;
   RaceMarkColor=clLime;
   RaceSize=5;
   RacePosMax=1443;
   ARacePos=0;

   Init();
}

// ~TCrono

TCrono::~TCrono()
{  delete AgujaM;
   delete AgujaS;
   delete AgujaD;

   delete Image;
   delete Font;
   delete Timer;

   delete ImageFondo1;
   delete ImageFondo2;
}

// Clear

void TCrono::Clear()
{  int h;

   h=Image->Canvas->TextHeight("0");

   Image->Canvas->Brush->Color=ColorFondo;
   Image->Canvas->Pen  ->Color=ColorFondo;
   Image->Canvas->Rectangle(0,0,Image->Width,h);

   if (Fondo)
   {  RaceOrigin=Point((Image->Width -ImageFondo2->Picture->Bitmap->Width )/2
                      ,(Image->Height-ImageFondo2->Picture->Bitmap->Height)*42/100);
      Image->Canvas->Draw(RaceOrigin.x,RaceOrigin.y,ImageFondo2->Picture->Graphic);
   }
}

// Continue

void TCrono::Continue()
{  if (Lapped) Lapped=false;
   else
   {  if (Timer->Enabled) return;

      Tick0=GetTickCount();
      Timer->Enabled=true;
   }

   if (Sound) MessageBeep(MB_ICONEXCLAMATION);
}

// HMSMSToTick

int TCrono::HMSMSToTick(int H,int M,int S,int MS)
{  int T;
   T=H*3600000+M*60000+S*1000+MS;
   return T;
}

// IniRead

void TCrono::IniRead()
{  char name[255];
   FILE *fdat;
   int i;

   if ((fdat=fopen("crono.ini","r"))!=NULL)
   {  fgets(name,255,fdat);
      Font->Name=name;
      Font->Name=Font->Name.SubString(0,Font->Name.Length()-1);

      fscanf(fdat,"%i ",&i);
      Font->Color=TColor(i);
      fscanf(fdat,"%i\n",&i);
      Font->Size=i;

      fscanf(fdat,"%i\n",&TickStop);
      fscanf(fdat,"%i\n",&Style);

      fscanf(fdat,"%i ",&i);
      AgujaM->Font->Color=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaM->ColorEsfera=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaM->ColorAguja=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaM->Divisiones=i;
      fscanf(fdat,"%i\n",&i);
      AgujaM->Numeros=bool(i);

      fscanf(fdat,"%i ",&i);
      AgujaS->Font->Color=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaS->ColorEsfera=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaS->ColorAguja=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaS->Divisiones=i;
      fscanf(fdat,"%i\n",&i);
      AgujaS->Numeros=bool(i);

      fscanf(fdat,"%i ",&i);
      AgujaD->Font->Color=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaD->ColorEsfera=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaD->ColorAguja=TColor(i);
      fscanf(fdat,"%i ",&i);
      AgujaD->Divisiones=i;
      fscanf(fdat,"%i\n",&i);
      AgujaD->Numeros=bool(i);

      fscanf(fdat,"%i\n",&i);
      Sound=bool(i);

      fscanf(fdat,"%i ",&i);
      RaceLineColor=TColor(i);
      fscanf(fdat,"%i ",&i);
      RaceMarkColor=TColor(i);
      fscanf(fdat,"%i ",&i);
      RaceSize=i;
      fscanf(fdat,"%i",&i);
      ARacePos=i;

      fclose(fdat);
   }
}

// Init

void TCrono::Init()
{  ATick0=0;

   Lapped=false;
   TickStopMade=false;

   Tick=0;

   Hours=0;
   Minutes=0;
   Seconds=0;
   MiliSeconds=0;

   RaceFondoInit();

   Timer->Enabled=false;
}

// Initialize

void TCrono::Initialize()
{  Init();
   Show();

   if (Sound) MessageBeep(MB_ICONHAND);
}

// IniWrite

void TCrono::IniWrite()
{  FILE *fres;

   fres=fopen("crono.ini","w");

   fprintf(fres,   "%s\n",Font->Name.c_str());
   fprintf(fres,"%i %i\n",Font->Color,Font->Size);
   fprintf(fres,   "%i\n",TickStop);
   fprintf(fres,   "%i\n",Style);

   fprintf(fres,"%i %i %i %i %i\n",AgujaM->Font->Color,AgujaM->ColorEsfera
                                  ,AgujaM->ColorAguja ,AgujaM->Divisiones
                                  ,int(AgujaM->Numeros));

   fprintf(fres,"%i %i %i %i %i\n",AgujaS->Font->Color,AgujaS->ColorEsfera
                                  ,AgujaS->ColorAguja ,AgujaS->Divisiones
                                  ,int(AgujaS->Numeros));

   fprintf(fres,"%i %i %i %i %i\n",AgujaD->Font->Color,AgujaD->ColorEsfera
                                  ,AgujaD->ColorAguja ,AgujaD->Divisiones
                                  ,int(AgujaD->Numeros));

   fprintf(fres,"%i\n",int(Sound));

   fprintf(fres,"%i %i %i %i",RaceLineColor,RaceMarkColor,RaceSize,ARacePos);

   fclose(fres);
}

// Lap

void TCrono::Lap()
{  if (!Timer->Enabled) return;
   Lapped=true;

   if (Sound) MessageBeep(MB_ICONQUESTION);
}

// RaceFondoLoad

void TCrono::RaceFondoLoad()
{  Fondo=true;

   ImageFondo1->Width =CronoF->ImageRace->Picture->Bitmap->Width;
   ImageFondo1->Height=CronoF->ImageRace->Picture->Bitmap->Height;
   ImageFondo1->Canvas->Draw(0,0,CronoF->ImageRace->Picture->Graphic);

   ImageFondo2->Width =ImageFondo1->Picture->Bitmap->Width;
   ImageFondo2->Height=ImageFondo1->Picture->Bitmap->Height;

   RaceFondoInit();
}

// RaceFondoInit

void TCrono::RaceFondoInit()
{  RacePos=0;
   ImageFondo2->Canvas->Draw(0,0,ImageFondo1->Picture->Graphic);
}

// RaceFuncArcLeft

TPoint TCrono::RaceFuncArcLeft(float x0,float y0,float r,float ar
                              ,float aa,float l,float lmax)
{  float a,radio,x,y;
   TPoint p;

   radio=r+ar*l/lmax;
   a=l/radio+aa;

   x0+=radio*sin(aa);
   y0-=radio*(1.0-cos(aa));

   x=x0-radio*sin(a);
   y=y0+radio*(1.0-cos(a));

   p=Point(int(x),int(y));

   return p;
}

// RaceFuncArcRight

TPoint TCrono::RaceFuncArcRight(float x0,float y0,float r,float ar
                               ,float aa,float l,float lmax)
{  float a,radio,x,y;
   TPoint p;

   radio=r+ar*l/lmax;
   a=l/radio+aa;

   x0-=radio*sin(aa);
   y0-=radio*(1.0-cos(aa));

   x=x0+radio*sin(a);
   y=y0+radio*(1.0-cos(a));

   p=Point(int(x),int(y));

   return p;
}

// RaceFuncLine

TPoint TCrono::RaceFuncLine(float x0,float y0,float kx,float ky,float l)
{  float x,y;
   TPoint p;

   x=x0+kx*l;
   y=y0+ky*l;

   p.x=int(x);
   p.y=int(y);

   return p;
}

// RaceMark

void TCrono::RaceMark(int x,int y)
{  Image->Canvas->Pen->Color=RaceMarkColor;
   Image->Canvas->Brush->Color=RaceMarkColor;
   Image->Canvas->Ellipse(x-RaceSize,y-RaceSize,x+RaceSize,y+RaceSize);
}

// RacePointGet

TPoint TCrono::RacePointGet(int pos)
{  float aa,ar,k,kx,ky,l,lmax,r,x0,y0;
   TPoint p;

   pos=(pos+ARacePos)%RacePosMax;

   RaceShowPos1:

   if (pos<174)
   {  x0=200.0;
      y0=11.0;

      k=1.0;
      kx=k;
      ky=1.0-k;

      l=float(pos);

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<205)
   {  x0=374.0;
      y0= 11.0;
      r = 14.0;
      ar=0.0;
      aa=0.0;

      l=float(pos)-174.0;
      lmax=205.0-174.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<212)
   {  x0=385.2;
      y0=33.4;

      k=0.35;
      kx=-k;
      ky=1.0-k;

      l=float(pos)-205.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<236)
   {  x0=382.75;
      y0= 37.95;
      r = 14.0;
      ar= -1.7;
      aa=60.0*M_PI/180.0;

      l=float(pos)-212.0;
      lmax=236.0-212.0;

      p=RaceFuncArcLeft(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<260)
   {  x0=391.74;
      y0= 56.18;

      k=0.85;
      kx=k;
      ky=1.0-k;

      l=float(pos)-236.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<285)
   {  x0=412.14;
      y0= 59.78;
      r=14.0+4.0*l/(285.0-260.0);
      ar=4.0;
      aa=170.0*M_PI/180.0;

      l=float(pos)-260.0;
      lmax=285.0-260.0;

      p=RaceFuncArcLeft(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<320)
   {  x0=432.13;
      y0= 48.33;

      k=0.35;
      kx=k;
      ky=-(1.0-k);

      l=float(pos)-285.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<340)
   {  x0=444.38;
      y0= 25.58;

      r=30.0;
      ar=-12.0;
      aa=300.0*M_PI/180.0;

      l=float(pos)-320.0;
      lmax=340.0-320.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<365)
   {  x0=462.14;
      y0= 16.15;

      r=20.0;
      ar=-3.5;
      aa=9.0*M_PI/180.0;

      l=float(pos)-340.0;
      lmax=365.0-340.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<447)
   {  x0=476.00;
      y0= 34.09;

      k=0.02;
      kx=k;
      ky=1.0-k;

      l=float(pos)-365.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<500)
   {  x0=478.00;
      y0=114.09;

      r=31.0;
      ar=-2.0;
      aa=90.0*M_PI/180.0;

      l=float(pos)-446.0;
      lmax=500.0-446.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<545)
   {  x0=439.72;
      y0=141.56;

      k=0.68;
      kx=-k;
      ky=-(1.0-k);

      l=float(pos)-500.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<570)
   {  x0=409.12;
      y0=127.16;

      r=45.0;
      ar=0.0;
      aa=200.0*M_PI/180.0;

      l=float(pos)-545.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<645)
   {  x0=389.13;
      y0=112.68;

      k=0.485;
      kx=-k;
      ky=-(1.0-k);

      l=float(pos)-570.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<670)
   {  x0=352.75;
      y0= 74.05;

      r=15.0;
      ar=0.0;
      aa=305.0*M_PI/180.0;

      l=float(pos)-645.0;
      lmax=670.0-645.0;

      p=RaceFuncArcLeft(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<685)
   {  x0=330.72;
      y0= 71.25;

      r=35.0;
      ar=0.0;
      aa=160.0*M_PI/180.0;

      l=float(pos)-670.0;
      lmax=685.0-670.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<740)
   {  x0=315.97;
      y0=73.25;

      k=0.98;
      kx=-k;
      ky=-(1.0-k);

      l=float(pos)-685.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<760)
   {  x0=262.07;
      y0= 72.15;

      r=35.0;
      ar=0.0;
      aa=185.0*M_PI/180.0;

      l=float(pos)-740.0;
      lmax=760.0-740.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<805)
   {  x0=243.70;
      y0=64.96;

      k=0.65;
      kx=-k;
      ky=-(1.0-k);

      l=float(pos)-760.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<823)
   {  x0=214.45;
      y0= 49.21;

      r=11.0;
      ar=0.0;
      aa=325.0*M_PI/180.0;

      l=float(pos)-805.0;
      lmax=823.0-805.0;

      p=RaceFuncArcLeft(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<847)
   {  x0=198.74;
      y0= 52.52;

      r=14.0;
      ar=0.0;
      aa=130.0*M_PI/180.0;

      l=float(pos)-823.0;
      lmax=847.0-823.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<880)
   {  x0=177.58;
      y0=52.85;

      k=0.6;
      kx=-k;
      ky=-(1.0-k);

      l=float(pos)-847.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<900)
   {  x0=157.78;
      y0= 39.65;

      r=26.0;
      ar=0.0;
      aa=325.0*M_PI/180.0;

      l=float(pos)-880.0;
      lmax=900.0-880.0;

      p=RaceFuncArcLeft(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<964)
   {  x0=138.77;
      y0=35.27;

      k=0.84;
      kx=-k;
      ky=1.0-k;

      l=float(pos)-900.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<987)
   {  x0=84.38;
      y0=45.97;

      r=25.0;
      ar=-4.5;
      aa=16.0*M_PI/180.0;

      l=float(pos)-964.0;
      lmax=987.0-964.0;

      p=RaceFuncArcLeft(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<1094)
   {  x0=69.82;
      y0=62.22;

      k=0.17;
      kx=-k;
      ky=1.0-k;

      l=float(pos)-987.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<1130)
   {  x0= 51.80;
      y0=150.20;

      r=12.5;
      ar=-1.0;
      aa=95.0*M_PI/180.0;

      l=float(pos)-1094.0;
      lmax=1130.0-1094.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<1200)
   {  x0=28.79;
      y0=149.40;

      k=0.14;
      kx=-k;
      ky=-(1.0-k);

      l=float(pos)-1130.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<1230)
   {  x0=19.13;
      y0=90.07;

      r=48.0;
      ar=0.0;
      aa=266.0*M_PI/180.0;

      l=float(pos)-1200.0;
      lmax=1130.0-1200.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<1260)
   {  x0=25.70;
      y0=62.29;

      k=0.42;
      kx=k;
      ky=-(1.0-k);

      l=float(pos)-1230.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<1278)
   {  x0=37.88;
      y0=45.48;

      r=21.0;
      ar=1.0;
      aa=305.0*M_PI/180.0;

      l=float(pos)-1260.0;
      lmax=1278.0-1260.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<1312)
   {  x0=51.81;
      y0=36.5;

      k=0.8;
      kx=k;
      ky=-(1.0-k);

      l=float(pos)-1278.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else if (pos<1327)
   {  x0=78.21;
      y0=29.90;

      r=15.0;
      ar=0;
      aa=190.0*M_PI/180.0;

      l=float(pos)-1312.0;
      lmax=1327.0-1312.0;

      p=RaceFuncArcLeft(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<1348)
   {  x0=89.03;
      y0=21.83;

      r=20.0;
      ar=-3.0;
      aa=295.0*M_PI/180.0;

      l=float(pos)-1327.0;
      lmax=1348.0-1327.0;

      p=RaceFuncArcRight(x0,y0,r,ar,aa,l,lmax);
   }
   else if (pos<1443)
   {  x0=105;
      y0=11;

      k=1.0;
      kx=k;
      ky=1.0-k;

      l=float(pos)-1348.0;

      p=RaceFuncLine(x0,y0,kx,ky,l);
   }
   else
   {  pos=0;
      goto RaceShowPos1;
   }

   p=Point(RaceOrigin.x+p.x,RaceOrigin.y+p.y);

   return p;
}

// RaceShowLineTo

void TCrono::RaceShowLineTo(int pos)
{  int i;
   TPoint p;

   ImageFondo2->Canvas->Pen->Width=2;
   ImageFondo2->Canvas->Pen->Color=RaceLineColor;

   if (RacePos>pos) RaceFondoInit();

   for (i=RacePos;i<pos;i++)
   {  p=RacePointGet(i);
      p.x-=RaceOrigin.x;
      p.y-=RaceOrigin.y;

      if (i==0) ImageFondo2->Canvas->MoveTo(p.x,p.y);
      else      ImageFondo2->Canvas->LineTo(p.x,p.y);
   }

   ImageFondo2->Canvas->Pen->Width=1;
   RacePos=pos;
}

// RaceShowPos

void TCrono::RaceShowPos()
{  TPoint p;

   if (RacePos>RacePosMax) RacePos-=RacePosMax;
   p=RacePointGet(RacePos);

   RaceMark(p.x,p.y);
}

// Resize

void TCrono::Resize()
{  Image->Picture->Bitmap->Width =Image->Width;
   Image->Picture->Bitmap->Height=Image->Height;

   Image->Canvas->Brush->Color=ColorFondo;
   Image->Canvas->Pen  ->Color=ColorFondo;
   Image->Canvas->Rectangle(0,0,Image->Width,Image->Height);

   if (Style==1)
   {  AgujaM->Centro=Point(Image->Width*1/5,Image->Height*11/14);
      AgujaS->Centro=Point(Image->Width*3/6,Image->Height*11/14);
      AgujaD->Centro=Point(Image->Width*4/5,Image->Height*11/14);

      AgujaM->ColorFondo=ColorFondo;
      AgujaS->ColorFondo=ColorFondo;
      AgujaD->ColorFondo=ColorFondo;

      AgujaM->Show();
      AgujaS->Show();
      AgujaD->Show();
   }

   Show();
}

// Show

void TCrono::Show()
{  int x;

   Clear();

   Image->Canvas->Font=Font;
   SetBkMode(Image->Canvas->Handle,TRANSPARENT);
   SetTextAlign(Image->Canvas->Handle,TA_CENTER);

   TickStringGet();
   x=Image->Width/2;

   if (Lapped)
   {  if (Seconds%2) Image->Canvas->TextOut(x,0,TickString);
   }
   else Image->Canvas->TextOut(x,0,TickString);

   if (Style==1)
   {  AgujaM->MoveTo(float(Minutes));
      AgujaS->MoveTo(float(Seconds));
      AgujaD->MoveTo(float(MiliSeconds)/100.0);
   }

   if (TickStop<=0) RaceShowLineTo(RacePosMax*(Tick%10000)/10000);
   else             RaceShowLineTo(RacePosMax*(Tick%TickStop)/TickStop);

   RaceShowPos();
}

// Start

void TCrono::Start()
{  if (Timer->Enabled) return;

   Init();
   Tick0=GetTickCount();
   Timer->Enabled=true;

   if (Sound) MessageBeep(MB_OK);
}

// Stop

void TCrono::Stop()
{  if (!Timer->Enabled) return;

   Lapped=false;

   TickTime();
   Show();
   Timer->Enabled=false;

   ATick0=Tick;

   if (Sound) MessageBeep(MB_OK);
}

// TickStringGet

void TCrono::TickStringGet()
{  if (!Lapped)
   {  TickString=FormatFloat( "00",float(Minutes))+":"+
                 FormatFloat( "00",float(Seconds))+":"+
                 FormatFloat("000",float(MiliSeconds));

      if (Hours>0) TickString=IntToStr(Hours)+":"+TickString;
   }
}

// TickTime

void TCrono::TickTime()
{  Tick=GetTickCount()-Tick0+ATick0;

   if (!TickStopMade)
   {  if ((TickStop>0)&&(Tick>=TickStop))
      {  TickStopMade=true;
         Tick=TickStop;

         Timer->Enabled=false;
         ATick0+=Tick;

         if (Sound) MessageBeep(MB_OK);
      }
   }

   Hours      =TickToHours(Tick);
   Minutes    =TickToMinutes(Tick,Hours);
   Seconds    =TickToSeconds(Tick,Hours,Minutes);
   MiliSeconds=TickToMiliSeconds(Tick,Hours,Minutes,Seconds);
}

// TickToHours

int TCrono::TickToHours(int atick)
{  int H;
   H=atick/3600000;
   return H;
}

// TickToMiliSeconds

int TCrono::TickToMiliSeconds(int atick,int H,int M,int S)
{  int MS;
   MS=atick-H*3600000-M*60000-S*1000;
   return MS;
}

// TickToMinutes

int TCrono::TickToMinutes(int atick,int H)
{  int M;
   M=(atick-H*3600000)/60000;
   return M;
}

// TickToSeconds

int TCrono::TickToSeconds(int atick,int H,int M)
{  int S;
   S=(atick-H*3600000-M*60000)/1000;
   return S;
}
